library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_textio.all;
use std.textio.all;
use std.env.stop;

entity fsm_stimuli is
	port(
		signal clk	 : in std_logic;
		signal tc_write : in std_logic;
		signal text_write : in std_logic;
		signal write_tc : in string(1 to 32);
		signal reset : in std_logic;
		signal mysimena	: in std_logic;
		signal mypreset : in std_logic;
		signal myreset	: in std_logic;
		signal myenable : in std_logic;
		signal myclk	: in std_logic;
		signal myd		: in std_logic;
		signal myq		: in std_logic
	);
end fsm_stimuli;

architecture rtl of fsm_stimuli is
--*************************************************************************************
-- PROCEDURE
--*************************************************************************************
	procedure pwrite(variable l: inout line; msg: in string) is
		variable tab : character := ';';
		begin
			write(l, msg);
			write(l, tab);
	end procedure;
	
	procedure pwrite(variable l: inout line; sig: in std_logic) is
		variable tab : character := ';';
		begin
			write(l, sig);
			write(l, tab);
	end procedure;
	
	procedure ptcwrite(variable l: inout line; sig: in string; file f: text) is
		variable tab : character := ';';
		begin
			write(l, sig);
			write(l, tab);
			writeline(f, l);
	end procedure;
--********************************************************************************
	
	type states is (a, b, c, d);
	signal state : states;
	
	begin
		process (reset, clk, text_write, tc_write)
		
		file stimulus 	: text open write_mode is ("stimoli.csv");
		variable lo 	: line;
		variable tab 	: character := ';';
		variable cont : natural;
				
			begin
				if (reset = '1') then
					state <= a;
				else
					case state is
						
						when a =>
							cont := 0;
							if (text_write = '1') then
								pwrite(lo, "#simena");
								pwrite(lo, "myd");		
								pwrite(lo, "myreset");
								pwrite(lo, "mypreset");
								pwrite(lo, "myenable");
								pwrite(lo, "myclk");
								pwrite(lo, "expected");
								pwrite(lo, "myq");
								pwrite(lo, "result");
								writeline(stimulus, lo);
							else
								state <= b;
							end if;
						
						when b =>
							if (tc_write = '1') then
								ptcwrite(lo, write_tc, stimulus);
							else
								state <= c;
							end if;
							
						when c =>
							if (clk = '1') then	
								if (tc_write = '0') then
									pwrite(lo, mysimena);
									pwrite(lo, myd);		
									pwrite(lo, myreset);
									pwrite(lo, mypreset);
									pwrite(lo, myenable);
									pwrite(lo, myclk);
									pwrite(lo, string'(" "));
									pwrite(lo, myq);
									pwrite(lo, string'(" "));
									writeline(stimulus, lo);
									cont := cont + 1;
								end if;
							elsif (tc_write = '1') then
								state <= b;
							elsif (cont = 30) then
								state <= d;
							end if;
							
						when d =>
							file_close(stimulus);
							state <= a;
							stop;

					end case;
				end if;
		end process;
		
end rtl;